'**************************************************
'**       3D RAW-FILE-FORMAT VIEWER              **
'**                            By Shadow Master  **
'**************************************************
'**   Este programa ilustra la carga de objetos  **
'**   3D en formato RAW. Este programa muestra   **
'**   ademas los algoritmos usados para la       **
'**   proyeccion y transformacion de objetos 3D  **
'**   en un plano bidimensional.                 **
'**                                              **
'**   Copyright (c) 2001 DamnSoft(ShadowMaster). **
'**   Todos los derechos reservados.Este         **
'**   programa es Freeware y puede ser modificado**
'**   y distribuido siempre y cuando se reconozca**
'**   la autoria original de ShadowMaster. Si    **
'**   deseas hacer uso de el, o parte de el en   **
'**   algun programa, contactate con su autor    **
'**   primero (shadows_of_despair@hotmail.com).  **
'**************************************************
'**  ADVERTENCIA: NO ME HAGO RESPONSABLE DE      **
'**  CUALQUIER FALLA O MALFUNCIONAMIENTO QUE     **
'**  PRESENTE TU PC DURANTE O AL FINALIZAR LA    **
'**  EJECUCION DE ESTE PROGRAMA.                 **
'**************************************************


'============= FUNCIONES ============
DECLARE SUB Show3DObject (XA!, YA!, ZA!, OColor%, A%, B%, Dist%)
DECLARE SUB LoadRAW (F$)


DEFINT A-Z
'=========== CONSTANTES ============
CONST UP = 72
CONST DOWN = 80
CONST LEFT = 75
CONST RIGHT = 77
CONST PI = 3.141593

'============= VARIBLES =============
DIM SHARED TotalVertex AS INTEGER
DIM SHARED SWIDTH, SHEIGHT AS INTEGER

TYPE RawVertex
X AS SINGLE
Y AS SINGLE
Z AS SINGLE
END TYPE

'Crearemos un array de vertices $DINAMICo cuyo tamao variara
'de acuerdo a la cantidad de vertices en el fichero a abrir

'$DYNAMIC:
DIM SHARED VERTEX(100) AS RawVertex
'$STATIC:

NULL$ = CHR$(0)

'******************************** MAIN **********************************
CLS
PRINT "3D RAW-FILE-FORMAT VIEWER    By Shadow Master"
PRINT "---------------------------------------------"
PRINT "Este programa utiliza un algoritmo muy simple"
PRINT "de proyeccion que permite mostrar un objeto 3D"
PRINT "en un plano bidimensional como una pantalla."
PRINT "Aprovechando la simpleza del formato RAW lo he"
PRINT "usado como ejemplo rapido para la carga de"
PRINT "objetos en 3D generados por otros programas"
PRINT "Una vez que la figura haya sido cargada puedes"
PRINT "rotarla alrededor del eje X e Y con las flechas"
PRINT "de direccion y alrededor del eje Z con las teclas"
PRINT "+ y -. Para finalizar el programa presiona ESC."
PRINT
PRINT "      <Pulsa cualquier tecla para continuar>"
DO: LOOP UNTIL INKEY$ <> ""
CLS

INPUT "Fichero:", F$
LoadRAW F$

SCREEN 12

SWIDTH = 640
SHEIGHT = 480

Refresh = 0
XANG! = 0: YANG! = 0: ZANG! = 0 'Angulos de rotacion por eje

Show3DObject XANG!, YANG!, ZANG!, 2, 0, 0, 2000

DO
XINC = 0: YINC = 0: ZINC = 0 'Incremento de la rotacion en cada eje tras
                             'haberse presionado alguna tecla

A$ = INKEY$

SELECT CASE A$
        CASE CHR$(0) + CHR$(UP)
        XINC! = -.5
        Refresh = 1

        CASE CHR$(0) + CHR$(DOWN)
        XINC! = .5
        Refresh = 1

        CASE CHR$(0) + CHR$(LEFT)
        YINC! = -.5
        Refresh = 1

        CASE CHR$(0) + CHR$(RIGHT)
        YINC! = .5
        Refresh = 1

        CASE "+"
        ZINC! = .5
        Refresh = 1

        CASE "-"
        ZINC! = -.5
        Refresh = 1
END SELECT

IF Refresh = 1 THEN
'Borramos el objeto dibujandolo en negro
Show3DObject XANG!, YANG!, ZANG!, 0, 0, 0, 2000

'incrementamos los angulos de rotacion por eje de acuerdo
'al contenido de xinc,yinc e zinc cuyo valor dependera de la
'tecla que haya sido presionada

XANG! = XANG! + XINC!
YANG! = YANG! + YINC!
ZANG! = ZANG! + ZINC!

'Mostramos el objeto
Show3DObject XANG!, YANG!, ZANG!, 2, 0, 0, 2000

Refresh = 0
END IF

LOOP UNTIL A$ = CHR$(13)

SCREEN 0

SUB LoadRAW (F$)
IF UCASE$(RIGHT$(F$, 4)) <> ".RAW" THEN F$ = F$ + ".RAW"

'Abrimos el archivo primero para contar cuantos Vertices posee y poder
'darle al array VerteX() las dimensiones correctas

OPEN F$ FOR INPUT AS #1
TV% = 0

DO
LINE INPUT #1, VAR$
IF LEN(VAR$) <= 0 THEN GOTO XtractLine
ASCII = ASC(VAR$)'El codigo Ascii del primer caracter
                                       'de la linea.

'Vemos si se trata de un numero, un signo - u otro caracter
'cualquiera. Si resultara ser un caracter cualquiera significa
'entonces que debemos saltar a la linea siguiente ya que ese es
'solo el nombre del objeto cuyos vertices siguen a continuacion

IF (ASCII >= 48 AND ASCII <= 57) OR ASCII = 45 THEN TV = TV + 1
XtractLine:
LOOP UNTIL EOF(1) = -1
CLOSE #1

TV = TV * 3

REDIM VERTEX(TV) AS RawVertex

CurrentVertex = 0

'Ahora lo abrimos para extraer los valores de cada vertice
OPEN F$ FOR INPUT AS #1
DO
LINE INPUT #1, V$
V$ = RTRIM$(LTRIM$(V$))
'La misma operacion realizada anteriormente solo que esta vez si es que la
'linea contiene valores de vertices, extraemos dichos valores y se los
'asignados a los elementos del array Vertex

IF LEN(V$) <= 0 THEN GOTO NotAValidLine
ASCII = ASC(V$)
IF (ASCII >= 48 AND ASCII <= 57) OR ASCII = 45 THEN

CurrentPos = 1

FOR VertexCounter = 0 TO 2
        FOR XYZCounter = 0 TO 2

        'Buscamos el proximo espacio en la subcadena que comienza
        'en CurrentPos

        V2$ = MID$(V$, CurrentPos)
        SPREF = INSTR(V2$, " ")

        'Si hemos llegado al final de la cadena lo mas probable es
        'que ya no hayan mas espacios (pero siempre es mejor asegurarse)
        'SPREF sera igual a 0, por lo que habra que corregir su valor para
        'que el ultimo valor de la linea sea extraido.
        IF SPREF = 0 THEN SPREF = LEN(V2$)

'Obtenemos el valor representado por la cadena entre CurrentPos
'y SPREF
VALUE! = VAL(MID$(V2$, 1, SPREF - 1))

CurrentPos = CurrentPos + SPREF

IF XYZCounter = 0 THEN VERTEX(CurrentVertex).X = VALUE!
IF XYZCounter = 1 THEN VERTEX(CurrentVertex).Y = VALUE!
IF XYZCounter = 2 THEN VERTEX(CurrentVertex).Z = VALUE!

NEXT
CurrentVertex = CurrentVertex + 1
NEXT
END IF
NotAValidLine:
LOOP UNTIL CurrentVertex = TV
CLOSE #1
TotalVertex = TV
END SUB

DEFSNG A-Z
           'Casi todos los valores que manejaremos seran SINGLE
SUB Show3DObject (XA!, YA!, ZA!, OColor%, A%, B%, Dist%)

XO% = SWIDTH% / 2
YO% = SHEIGHT% / 2

'El angulo que forma el
'observador con el plano YZ (A) y con el plano XZ (B)
angA = A% * PI / 180
angB = B% * PI / 180

'hacemos esto para facilitarle las ecuaciones al computador
a1 = COS(angA): a2 = SIN(angA)
b1 = COS(angB): b2 = SIN(angB)

L% = 0
DO
FOR J% = L% TO L% + 2
X = VERTEX(J%).X
Y = VERTEX(J%).Y
Z = VERTEX(J%).Z

'Modificamos las coordenadas del objeto de acuerdo a si ha sido rotado
'(los valores de la rotacion en cada eje estan almacenados en XA,YA,ZA)

IF XA <> 0 THEN
YT = Y * COS(XA) + Z * SIN(XA)
ZT = -Y * SIN(XA) + Z * COS(XA)
Y = YT
Z = ZT
END IF

IF YA <> 0 THEN
XT = X * COS(YA) + Z * SIN(YA)
ZT = -X * SIN(YA) + Z * COS(YA)
X = XT
Z = ZT
END IF

IF ZA <> 0 THEN
XT = X * COS(ZA) + Y * SIN(ZA)
YT = -X * SIN(ZA) + Y * COS(ZA)
X = XT
Y = YT
END IF


'Proyectamos en una pantalla 2D los puntos x,y,z usando las siguientes
'ecuaciones:
X1 = a1 * X - a2 * Z
Y1 = Y * b1 - Z * a1 * b2 - X * a2 * b2
Z1 = Z * a1 * b1 + X * a2 * b1 + Y * b2
X1 = Dist% * X1 / (Dist% - Z1)
Y1 = Dist% * Y1 / (Dist% - Z1)


'Sumandole a las coordenadas de los puntos de nuestro dibujo las coordenadas
'del origen, logramos que la imagen se inicie en el centro
X1 = X1 + XO%
Y1 = -Y1 + YO%

IF J% = L% THEN TRINIX = X1: TRINIY = Y1
IF J% = L% + 1 THEN LINE (TRINIX, TRINIY)-(X1, Y1), OColor%
IF J% = L% + 2 THEN LINE (X1, Y1)-(TRINIX, TRINIY), OColor%
NEXT
L% = L% + 3
LOOP UNTIL L% = TotalVertex%

END SUB

